# 
extern "mvn pre-clean clean post-clean validate initialize generate-sources process-sources generate-resources process-resources compile process-classes generate-test-sources process-test-sources generate-test-resources process-test-resources test-compile process-test-classes testprepare-package package pre-integration-test integration-test post-integration-test verify install deploy pre-site site post-site site-deploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# If project list is specified, also build projects required by the list
extern "mvn" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Clean the build
extern "mvn clean:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-clean-plugin
extern "mvn clean:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Compiles application sources
extern "mvn compiler:compile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-compiler-plugin
extern "mvn compiler:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Compiles application test sources.
extern "mvn compiler:testCompile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-deploy-plugin
extern "mvn deploy:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Installs the artifact in the remote repository.
extern "mvn deploy:deploy-file" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys an artifact to remote repository.
extern "mvn deploy:deploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-failsafe-plugin
extern "mvn failsafe:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run integration tests using Surefire.
extern "mvn failsafe:integration-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Verify integration tests ran using Surefire.
extern "mvn failsafe:verify" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Installs the project's main artifact, and any other artifacts attached by other plugins in the lifecycle, to the local repository.
extern "mvn install:install" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-install-plugin
extern "mvn install:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Installs a file in the local repository.
extern "mvn install:install-file" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy resources for the test source code to the test output directory
extern "mvn resources:testResources" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy resources of the configured plugin attribute resources
extern "mvn resources:copy-resources" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-resources-plugin
extern "mvn resources:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy resources for the main source code to the main output directory
extern "mvn resources:resources" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Adds the site descriptor (site.xml) to the list of files to be installed/deployed
extern "mvn site:attach-descriptor" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys the generated site
extern "mvn site:deploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays the effective site descriptor
extern "mvn site:effective-site" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-site-plugin
extern "mvn site:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Bundles the site output into a JAR so that it can be deployed to a repository.
extern "mvn site:jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts the site up, rendering documents as requested for faster editing. It uses Jetty as the web server.
extern "mvn site:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the site for a single project
extern "mvn site:site" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys the generated site to a local staging or mock directory
extern "mvn site:stage" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys the generated site to a staging or mock URL
extern "mvn site:stage-deploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-surefire-plugin
extern "mvn surefire:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run tests using Surefire.
extern "mvn surefire:test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-verifier-plugin
extern "mvn verifier:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Verifies the existence or non-existence of files/directories and optionally checks file content against a regular expression.
extern "mvn verifier:verify" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds J2EE Enterprise Archive (EAR) files.
extern "mvn ear:ear" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the EAR deployment descriptor file(s).
extern "mvn ear:generate-application-xml" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-ear-plugin
extern "mvn ear:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Build an EJB (and optional client) from the current project.
extern "mvn ejb:ejb" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-ejb-plugin
extern "mvn ejb:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-jar-plugin
extern "mvn jar:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Build a JAR from the current project.
extern "mvn jar:jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Build a JAR of the test classes for the current project.
extern "mvn jar:test-jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-rar-plugin
extern "mvn rar:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds J2EE Resource Adapter Archive (RAR) files.
extern "mvn rar:rar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-shade-plugin
extern "mvn shade:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Mojo that performs shading delegating to the Shader component.
extern "mvn shade:shade" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Aggregate sources for all modules in an aggregator project.
extern "mvn source:aggregate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This plugin bundles all the sources into a jar archive.
extern "mvn source:jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This goal bundles all the test sources into a jar archive
extern "mvn source:test-jar-no-fork" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This plugin bundles all the test sources into a jar archive.
extern "mvn source:test-jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This plugin bundles all the test sources into a jar archive.
extern "mvn source:generated-test-jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-source-plugin
extern "mvn source:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This goal bundles all the sources into a jar archive
extern "mvn source:jar-no-fork" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a changelog report.
extern "mvn changelog:changelog" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a file activity report.
extern "mvn changelog:file-activity" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a developer activity report.
extern "mvn changelog:dev-activity" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-changelog-plugin
extern "mvn changelog:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which validate the changes.xml file.
extern "mvn changes:changes-validate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Check that changes.xml has the necessary data for a release announcement
extern "mvn changes:changes-check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which downloads issues from GitHub and generates a report.
extern "mvn changes:github-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which generate an announcement from the announcement template.
extern "mvn changes:announcement-generate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which downloads issues from the Issue Tracking System and generates a report.
extern "mvn changes:trac-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which creates a nicely formatted Changes Report in html format from a changes.xml file.
extern "mvn changes:changes-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which sends an announcement through email.
extern "mvn changes:announcement-mail" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which downloads issues from the Issue Tracking System and generates a report.
extern "mvn changes:jira-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-changes-plugin
extern "mvn changes:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Perform Checkstyle analysis
extern "mvn checkstyle:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Perform Checkstyle analysis and generate an HTML report
extern "mvn checkstyle:checkstyle" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Perform Checkstyle analysis and generate an aggregate HTML report
extern "mvn checkstyle:checkstyle-aggregate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-checkstyle-plugin
extern "mvn checkstyle:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a Description of a Project (DOAP) file
extern "mvn doap:generate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-doap-plugin
extern "mvn doap:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Checks a plugin's documentation for the standard minimums.
extern "mvn docck:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-docck-plugin
extern "mvn docck:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates documentation for the Java code in an aggregator project using the standard Javadoc Tool.
extern "mvn javadoc:aggregate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Bundles the Javadoc documentation for main Java code in an aggregator project into a jar using the standard Javadoc Tool.
extern "mvn javadoc:aggregate-jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Fix Javadoc documentation and tags for the Java code for the project. See Where Tags Can Be Used.
extern "mvn javadoc:fix" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-javadoc-plugin
extern "mvn javadoc:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Bundle the Javadoc into a jar
extern "mvn javadoc:jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate documentation
extern "mvn javadoc:javadoc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate documentation
extern "mvn javadoc:javadoc-no-fork" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Bundle AbstractJavadocMojo.javadocDirectory
extern "mvn javadoc:resource-bundle" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates documentation for the Java Test code
extern "mvn javadoc:test-aggregate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Bundle documentation for Java Test Code into a jar
extern "mvn javadoc:test-aggregate-jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Fix Javadoc documentation and tags for the Test Java code
extern "mvn javadoc:test-fix" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Bundles the Javadoc documentation for test Java code into a jar
extern "mvn javadoc:test-jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates documentation for the Java Test code
extern "mvn javadoc:test-javadoc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate documentation for the Java Test code
extern "mvn javadoc:test-javadoc-no-fork" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Bundle TestJavadocJar.testJavadocDirectory
extern "mvn javadoc:test-resource-bundle" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a combined JXR report in an aggregating project.
extern "mvn jxr:aggregate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-jxr-plugin
extern "mvn jxr:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates an html-based, cross referenced version of Java source code for a project.
extern "mvn jxr:jxr" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a combined JXR report for test code in an aggregating project.
extern "mvn jxr:test-aggregate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates an html-based, cross referenced version of Java source code for a project's test sources.
extern "mvn jxr:test-jxr" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a Linkcheck report.
extern "mvn linkcheck:linkcheck" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-linkcheck-plugin
extern "mvn linkcheck:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Fail the build if there were any PMD violations in the source code.
extern "mvn pmd:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates a report for PMD's CPD tool. See http://pmd.sourceforge.net/cpd.html for more detail.
extern "mvn pmd:cpd" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Fail the build if there were any CPD violations in the source code.
extern "mvn pmd:cpd-check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-pmd-plugin
extern "mvn pmd:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates a PMD report.
extern "mvn pmd:pmd" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Continuous Integration System report.
extern "mvn project-info-reports:cim" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Dependencies report.
extern "mvn project-info-reports:dependencies" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Dependency Convergence report for reactor builds.
extern "mvn project-info-reports:dependency-convergence" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates code snippets to be added to build tools.
extern "mvn project-info-reports:dependency-info" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Dependency Management report.
extern "mvn project-info-reports:dependency-management" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Distribution Management report.
extern "mvn project-info-reports:distribution-management" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-project-info-reports-plugin
extern "mvn project-info-reports:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the project index page.
extern "mvn project-info-reports:index" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Issue Tracking report.
extern "mvn project-info-reports:issue-tracking" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project License report.
extern "mvn project-info-reports:license" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Mailing List report.
extern "mvn project-info-reports:mailing-list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Modules report.
extern "mvn project-info-reports:modules" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Plugin Management report.
extern "mvn project-info-reports:plugin-management" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Plugins report.
extern "mvn project-info-reports:plugins" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Team report.
extern "mvn project-info-reports:project-team" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Project Source Code Management (SCM) report.
extern "mvn project-info-reports:scm" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the project information reports summary.
extern "mvn project-info-reports:summary" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create Failsafe Test Report html 
extern "mvn surefire-report:failsafe-report-only" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-surefire-report-plugin
extern "mvn surefire-report:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create Surefire Test Report html
extern "mvn surefire-report:report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create Surefire Test Report html
extern "mvn surefire-report:report-only" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate Ant build files.
extern "mvn ant:ant" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Clean all Ant build files.
extern "mvn ant:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-ant-plugin
extern "mvn ant:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-antrun-plugin
extern "mvn antrun:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Maven AntRun Mojo
extern "mvn antrun:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Crawl a Maven repository (filesystem, not HTTP) and creates a catalog file.
extern "mvn archetype:crawl" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Retrieve an archetype from the remote repository
extern "mvn archetype:create" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates an archetype project from the current project
extern "mvn archetype:create-from-project" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate new project from an archetype, or update project if using a partial archetype
extern "mvn archetype:generate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-archetype-plugin
extern "mvn archetype:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Execute the archetype integration tests
extern "mvn archetype:integration-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Build a JAR from the current Archetype project.
extern "mvn archetype:jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Updates the local catalog
extern "mvn archetype:update-local-catalog" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Assemble an application bundle or distribution using an assembly descriptor from the command line
extern "mvn assembly:assembly" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Assemble an application bundle or distribution from an assembly descriptor
extern "mvn assembly:attached" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Assemble an application bundle or distribution
extern "mvn assembly:directory" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Like assembly:attached, but ignore the <formats/> section
extern "mvn assembly:directory-inline" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Assemble an application bundle or distribution from an assembly descriptor
extern "mvn assembly:directory-single" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-assembly-plugin
extern "mvn assembly:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Assemble an application bundle or distribution from an assembly descriptor
extern "mvn assembly:single" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Unpack project dependencies. Currently supports dependencies of type jar and zip.
extern "mvn assembly:unpack" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Analyzes the dependencies of this project
extern "mvn dependency:analyze" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Look for dependency mismatches in your dependencyManagement section
extern "mvn dependency:analyze-dep-mgt" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Determine duplicate dependencies
extern "mvn dependency:analyze-duplicate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Analyze the dependencies of this project
extern "mvn dependency:analyze-only" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Analyze the dependencies of this project and produce a report
extern "mvn dependency:analyze-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This goal will output a classpath string of dependencies from the local repository to a file or log.
extern "mvn dependency:build-classpath" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal that copies a list of artifacts from the repository to defined locations.
extern "mvn dependency:copy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal that copies the project dependencies from the repository to a defined location.
extern "mvn dependency:copy-dependencies" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays all ancestor POMs of the project
extern "mvn dependency:display-ancestors" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Resolves a single artifact, eventually transitively, from the specified remote repositories
extern "mvn dependency:get" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Resolve all project dependencies
extern "mvn dependency:go-offline" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-dependency-plugin
extern "mvn dependency:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays the list of dependencies for this project.
extern "mvn dependency:list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Resolve all project dependencies and then lists the repositories used
extern "mvn dependency:list-repositories" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Set a property pointing to the artifact file for each project dependency
extern "mvn dependency:properties" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Remove the project dependencies from the local repository, and optionally re-resolve them.
extern "mvn dependency:purge-local-repository" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Resolve project dependencies
extern "mvn dependency:resolve" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal that resolves all project plugins and reports and their dependencies.
extern "mvn dependency:resolve-plugins" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal that resolves the project source dependencies from the repository.
extern "mvn dependency:sources" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays the dependency tree for this project.
extern "mvn dependency:tree" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal that retrieves a list of artifacts from the repository and unpacks them in a defined location.
extern "mvn dependency:unpack" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal that unpacks the project dependencies from the repository to a defined location.
extern "mvn dependency:unpack-dependencies" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This goal displays the current platform information.
extern "mvn enforcer:display-info" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This goal executes the defined enforcer-rules once per module.
extern "mvn enforcer:enforce" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-enforcer-plugin
extern "mvn enforcer:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-gpg-plugin
extern "mvn gpg:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Sign project artifact, the POM, and attached artifacts with GnuPG for deployment.
extern "mvn gpg:sign" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Signs artifacts and installs the artifact in the remote repository.
extern "mvn gpg:sign-and-deploy-file" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays the supported Plugin expressions used by Maven.
extern "mvn help:expressions" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays a list of the profiles which are currently active for this build.
extern "mvn help:active-profiles" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays the calculated settings as XML for this project
extern "mvn help:effective-settings" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays a list of the platform details like system properties and environment variables.
extern "mvn help:system" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays the effective POM as an XML for this build, with the active profiles factored in.
extern "mvn help:effective-pom" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-help-plugin
extern "mvn help:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays a list of available profiles under the current project
extern "mvn help:all-profiles" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays a list of the attributes for a Maven Plugin and/or goals (aka Mojo - Maven plain Old Java Object).
extern "mvn help:describe" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Evaluates Maven expressions given by the user in an interactive mode.
extern "mvn help:evaluate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-invoker-plugin
extern "mvn invoker:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Installs the project artifacts of the main build into the local repository
extern "mvn invoker:install" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Searches for integration test Maven projects, and executes each, collecting a log in the project directory
extern "mvn invoker:integration-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a report based on the results of the Maven invocations
extern "mvn invoker:report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Searches for integration test Maven projects, and executes each, collecting a log in the project directory, and outputting the results to the command line.
extern "mvn invoker:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Checks the results of maven-invoker-plugin based integration tests and fails the build if any tests failed.
extern "mvn invoker:verify" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-jarsigner-plugin
extern "mvn jarsigner:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Signs a project artifact and attachments using jarsigner.
extern "mvn jarsigner:sign" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Checks the signatures of a project artifact and attachments using jarsigner.
extern "mvn jarsigner:verify" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Apply one or more patches to project sources.
extern "mvn patch:apply" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-patch-plugin
extern "mvn patch:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-pdf-plugin
extern "mvn pdf:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a PDF document for a project.
extern "mvn pdf:pdf" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update the user plugin registry (if it's in use) to reflect the version we're installing.
extern "mvn plugin:updateRegistry" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Plugin's documentation report.
extern "mvn plugin:report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate Xdoc files for the project mojos or goals.
extern "mvn plugin:xdoc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Inject any plugin-specific artifact metadata to the project's artifact, for subsequent installation and deployment
extern "mvn plugin:addPluginArtifactMetadata" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-plugin-plugin
extern "mvn plugin:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a HelpMojo class.
extern "mvn plugin:helpmojo" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a plugin descriptor
extern "mvn plugin:descriptor" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Perform a release from SCM
extern "mvn release:perform" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Rollback changes made by a previous release
extern "mvn release:rollback" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Prepare for a release in SCM, fully resolving dependencies for the purpose of producing a 'release POM'.
extern "mvn release:prepare-with-pom" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Perform a release from SCM to a staging repository
extern "mvn release:stage" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update the POM versions for a project
extern "mvn release:update-versions" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Prepare for a release in SCM
extern "mvn release:prepare" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Clean up after a release preparation
extern "mvn release:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-release-plugin
extern "mvn release:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Branch a project in SCM
extern "mvn release:branch" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Pull down resourceBundles containing remote resources and process the resources contained inside
extern "mvn remote-resources:process" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-remote-resources-plugin
extern "mvn remote-resources:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Bundle up resources that should be considered as a remote-resource.
extern "mvn remote-resources:bundle" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which creates an upload bundle for a project built with Maven.
extern "mvn repository:bundle-create" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Packs artifacts already available in a local repository in a bundle for an upload requests
extern "mvn repository:bundle-pack" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-repository-plugin
extern "mvn repository:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display the modification status of the files in the configured scm url.
extern "mvn scm:status" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Branch the project.
extern "mvn scm:branch" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Validate scm connection string.
extern "mvn scm:validate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Commit changes to the configured scm url.
extern "mvn scm:checkin" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display the difference of the working copy with the latest copy in the configured scm url.
extern "mvn scm:diff" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update the local working copy with the latest source from the configured scm url.
extern "mvn scm:update" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Add a file set to the project.
extern "mvn scm:add" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Mark a set of files for deletion.
extern "mvn scm:remove" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Unedit/unlock a set of files.
extern "mvn scm:unedit" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Pull the project source from the configured scm and execute the configured goals.
extern "mvn scm:bootstrap" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Get a fresh copy of the latest source from the configured scm url.
extern "mvn scm:checkout" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Tag the project.
extern "mvn scm:tag" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Edit/lock a set of files.
extern "mvn scm:edit" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This mojo will fail the build if there is any local modifications
extern "mvn scm:check-local-modification" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Get the list of project files.
extern "mvn scm:list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Dump changelog contents to console. It is mainly used to test maven-scm-api's changelog command.
extern "mvn scm:changelog" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-scm-plugin
extern "mvn scm:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Get a fresh exported copy of the latest source from the configured scm url.
extern "mvn scm:export" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Updates all projects in a multi project build
extern "mvn scm:update-subprojects" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Publish a content to scm
extern "mvn scm-publish:publish-scm" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-scm-publish-plugin
extern "mvn scm-publish:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Empty goal, provided only to set loose the lifecycle.
extern "mvn scm-publish:scmpublish" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copies artifacts from one repository to another repository.
extern "mvn stage:copy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-stage-plugin
extern "mvn stage:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-toolchains-plugin
extern "mvn toolchains:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Check that toolchains requirements are met by currently configured toolchains
extern "mvn toolchains:toolchain" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deletes the .project, .classpath, .wtpmodules files and .settings folder used by Eclipse.
extern "mvn eclipse:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Configure Eclipse Workspace features
extern "mvn eclipse:configure-workspace" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate Eclipse configuration files
extern "mvn eclipse:eclipse" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on maven-eclipse-plugin
extern "mvn eclipse:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Install plugins resolved from the Maven repository system into an Eclipse instance.
extern "mvn eclipse:install-plugins" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates MyEclipse configuration files
extern "mvn eclipse:myeclipse" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deletes configuration files used by MyEclipse
extern "mvn eclipse:myeclipse-clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the rad-6 configuration files.
extern "mvn eclipse:rad" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deletes the config files used by Rad-6. the files .j2ee and the file .websettings
extern "mvn eclipse:rad-clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Removes the not-available marker files from the repository.
extern "mvn eclipse:remove-cache" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# For all projects currently part of the workspace, all references to the M2_REPO classpath variable are resolved
extern "mvn eclipse:resolve-workspace-dependencies" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Add eclipse artifacts from an eclipse installation to the local repo
extern "mvn eclipse:to-maven" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss Hibernate exploded Archive.
extern "mvn jboss-packaging:har-exploded" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss ESB Archive.
extern "mvn jboss-packaging:esb" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss ESB exploded Archive.
extern "mvn jboss-packaging:esb-exploded" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss AOP Archive.
extern "mvn jboss-packaging:aop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss Spring Archive.
extern "mvn jboss-packaging:spring" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss Hibernate Archive
extern "mvn jboss-packaging:har" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on jboss-packaging-maven-plugin
extern "mvn jboss-packaging:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss Process Archive.
extern "mvn jboss-packaging:par" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss Service Archive.
extern "mvn jboss-packaging:sar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss Service in place exploded Archive.
extern "mvn jboss-packaging:sar-inplace" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Builds a deployable JBoss Service exploded Archive.
extern "mvn jboss-packaging:sar-exploded" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# The wsadmin goal executes the WebSphere command-line administration tool with the specified arguments.
extern "mvn was6:wsAdmin" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Lists all the applications installed on a WebSphere Server or Cell
extern "mvn was6:wsListApps" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts a standalone server instance
extern "mvn was6:wsStartServer" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Start an application on a WebSphere Server or in a WebSphere Cell
extern "mvn was6:wsStartApp" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Cleans out temporary resources and generated sources.
extern "mvn was6:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stop a standalone server instance
extern "mvn was6:wsStopServer" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stop an application on a WebSphere Server or in a WebSphere Cell
extern "mvn was6:wsStopApp" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Executes the ServiceDeploy command against an archive file (Ear, Zip or Jar) to produce an ear file that can be deployed on Process Server
extern "mvn was6:servicedeploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Installs an EAR into WebSphere Application Server.
extern "mvn was6:installApp" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate default IBM WebSphere Bindings for the specified EAR file
extern "mvn was6:wsDefaultBindings" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Executes the endpoint enabler ant task on the EAR archive.
extern "mvn was6:endpointEnabler" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates Java classes and deployment descriptor templates from a Web Services Description Language (WSDL) file
extern "mvn was6:wsdl2java" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on was6-maven-plugin
extern "mvn was6:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates EJB RMIC stub sources
extern "mvn was6:ejbdeploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Uninstall an existing application from a WebSphere Server or Cell
extern "mvn was6:wsUninstallApp" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stop an artifact on Weblogic server(s) or cluster(s).
extern "mvn weblogic:stop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Start an artifact on Weblogic server(s) or cluster(s).
extern "mvn weblogic:start" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Undeploy artifacts from Weblogic server(s) or cluster(s).
extern "mvn weblogic:undeploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run the weblogic appc compiler against an artifact.
extern "mvn weblogic:appc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs Client Gen on a given WSDL
extern "mvn weblogic:clientgen9" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# List the atifacts on Weblogic server(s) or cluster(s).
extern "mvn weblogic:listapps" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on weblogic-maven-plugin
extern "mvn weblogic:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This class generates wsdl from ear/war package
extern "mvn weblogic:wsdlgen" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Redeploy artifact on Weblogic server(s) or cluster(s).
extern "mvn weblogic:redeploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs the JWSC compiler task for web service enabled code.
extern "mvn weblogic:jwsc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs Service Gen on a given WSDL.
extern "mvn weblogic:servicegen" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploy an artifact to Weblogic servers(s) or cluster(s).
extern "mvn weblogic:deploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on antlr-maven-plugin
extern "mvn antlr:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates Antlr documentation from grammar files.
extern "mvn antlr:html" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates files based on grammar files with Antlr tool.
extern "mvn antlr:generate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates an AspectJ HTML report using the ajdoc tool and format.
extern "mvn aspectj:aspectj-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Weaves all main classes.
extern "mvn aspectj:compile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create eclipse configuration of aspectJ
extern "mvn aspectj:EclipseAjcMojo" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on aspectj-maven-plugin
extern "mvn aspectj:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Weaves all test classes.
extern "mvn aspectj:test-compile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A Plugin for generating WSDL files using Axis Java2WSDL.
extern "mvn axistools:java2wsdl" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on axistools-maven-plugin
extern "mvn axistools:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A Plugin for generating stubs for WSDL files using Axis WSDL2Java.
extern "mvn axistools:wsdl2java" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Utility for turning xml into Axis deployment operations (wraps org.apache.axis.utils.Admin)
extern "mvn axistools:admin" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on castor-maven-plugin
extern "mvn castor:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A mojo that uses Castor MappingTool to generate mapping files from a set of Classes. MappingTool.
extern "mvn castor:mappings" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A mojo that uses Castor MappingTool to generate mapping files from a single Class. MappingTool.
extern "mvn castor:mapping" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A mojo that uses Castor to generate a collection of javabeans from an XSD
extern "mvn castor:generate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Commons-attributes compiler.
extern "mvn commons-attributes:compile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Commons-attributes compiler for tests.
extern "mvn commons-attributes:test-compile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs the project with a debugger port hook (optionally suspended).
extern "mvn gwt:debug" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Merges GWT servlet elements into deployment descriptor (and non GWT servlets into shell)
extern "mvn gwt:mergewebxml" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on gwt-maven-plugin
extern "mvn gwt:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Invokes the GWT Compiler
extern "mvn gwt:compile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Add GWT java source code and module descriptor as resources to project jar
extern "mvn gwt:source-jar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy GWT java source code and module descriptor as resources in the build outputDirectory
extern "mvn gwt:resources" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# see http://code.google.com/webtoolkit/doc/latest/DevGuideCompileReport.html#Usage
extern "mvn gwt:compile-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates CSS interfaces for css files
extern "mvn gwt:css" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs GWT modules with Super Dev Mode.
extern "mvn gwt:run-codeserver" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which creates Eclipse lauch configurations for GWTTestCases.
extern "mvn gwt:eclipseTest" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Mimic surefire to run GWTTestCases during integration-test phase, until SUREFIRE-508 is fixed
extern "mvn gwt:test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Cleanup the webapp directory for GWT module compilation output
extern "mvn gwt:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which generate Async interface.
extern "mvn gwt:generateAsync" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates I18N interfaces for constants and messages files.
extern "mvn gwt:i18n" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs the project in the GWT (Classic or Super) Dev Mode for development.
extern "mvn gwt:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which creates Eclipse lauch configurations for GWT modules.
extern "mvn gwt:eclipse" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 'hbm2doc' generates html documentation a'la javadoc for the database schema.
extern "mvn hibernate3:hbm2doc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a set of .hbm files
extern "mvn hibernate3:hbm2hbmxml" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a set of DAOs.
extern "mvn hibernate3:hbm2dao" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Execute a HQL query statements
extern "mvn hibernate3:query" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal for 'cglib' or 'javassist' instrumentation.
extern "mvn hibernate3:instrument" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 'AntRun' wrapper.
extern "mvn hibernate3:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 'hbmtemplate' generic exporter that can be controlled by a user provided template or class.
extern "mvn hibernate3:hbmtemplate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 'hbm2cfgxml' generates a hibernate.cfg.xml
extern "mvn hibernate3:hbm2cfgxml" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 'hbm2ddl' lets you run schemaexport and schemaupdate which generates the appropriate SQL DDL
extern "mvn hibernate3:hbm2ddl" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on hibernate3-maven-plugin
extern "mvn hibernate3:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 'hbmlint' scans mappings for errors
extern "mvn hibernate3:hbmlint" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 'hbm2java' is a java code generator
extern "mvn hibernate3:hbm2java" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Process CORBA IDL test files in IDLJ
extern "mvn idlj:generate-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on idlj-maven-plugin
extern "mvn idlj:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Process CORBA IDL files in IDLJ.
extern "mvn idlj:generate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Parses a JJTree grammar file (*.jjt) and transforms it to Java source files and a JavaCC grammar file
extern "mvn javacc:jjtree" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Parses a JTB file and transforms it into source files for an AST and a JavaCC grammar file which automatically builds the AST
extern "mvn javacc:jtb" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# JJDoc takes a JavaCC parser specification and produces documentation for the BNF grammar
extern "mvn javacc:jjdoc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Preprocesses ordinary grammar files (*.jtb) with JTB and passes the output to JavaCC in order to finally generate a parser with parse tree actions
extern "mvn javacc:jtb-javacc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on javacc-maven-plugin
extern "mvn javacc:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Preprocesses decorated grammar files (*.jjt) with JJTree and passes the output to JavaCC in order to finally generate a parser with parse tree actions.
extern "mvn javacc:jjtree-javacc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Parses a JavaCC grammar file (*.jj) and transforms it to Java source files. Detailed information about the JavaCC options can be found on the JavaCC website.
extern "mvn javacc:javacc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on jaxb2-maven-plugin
extern "mvn jaxb2:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Mojo that creates XML schema(s) from compile-scope Java sources or binaries by invoking the JAXB SchemaGenerator
extern "mvn jaxb2:schemagen" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Mojo that creates XML schema(s) from test-scope Java testSources or binaries by invoking the JAXB SchemaGenerator
extern "mvn jaxb2:testSchemagen" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Mojo that creates test-scope Java source or binaries from XML schema(s) by invoking the JAXB XJC binding compiler
extern "mvn jaxb2:testXjc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Mojo that creates compile-scope Java source or binaries from XML schema(s) by invoking the JAXB XJC binding compiler
extern "mvn jaxb2:xjc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn jpox:enhance" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the Schema from the JDO mappings and the enhanced class files.
extern "mvn jpox:schema-create" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Provides detailed information about the database - limits and datatypes support
extern "mvn jpox:schema-dbinfo" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deletes all database tables required for a set of JDO MetaData files (and enhanced classes) from the database schema.
extern "mvn jpox:schema-delete" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Provides a detailed information about the database schema. The output is written to console/terminal. 
extern "mvn jpox:schema-info" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Validates all database tables required for a set of JDO MetaData files (and classes) for correct structure
extern "mvn jpox:schema-validate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which reports on the test source files using JSLint.
extern "mvn jslint:test-jslint" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which reports on the source files using JSLint.
extern "mvn jslint:jslint" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on jslint-maven-plugin
extern "mvn jslint:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Test goal implementation of the generate html mojo.
extern "mvn js-import:test-generate-html" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Main goal implementation of the generate html mojo.
extern "mvn js-import:generate-html" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Test goal implementation of the import mojo.
extern "mvn js-import:test-import-js" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Main goal implementation of the import mojo.
extern "mvn js-import:import-js" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on js-import-maven-plugin
extern "mvn js-import:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn jspc:compile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn jspc:testCompile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Processes Application model classes and enhances them by running Open JPA Enhancer tool.
extern "mvn openjpa:test-enhance" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on openjpa-maven-plugin
extern "mvn openjpa:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Processes Application model classes and enhances them by running Open JPA Enhancer tool
extern "mvn openjpa:enhance" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Executes the schema generation via the OpenJPA MappingTool.
extern "mvn openjpa:schema" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Executes the SQL generation via the OpenJPA MappingTool.
extern "mvn openjpa:sql" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on rmic-maven-plugin
extern "mvn rmic:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Compiles rmi stubs and skeleton classes from a remote implementation class
extern "mvn rmic:test-rmic" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Compiles rmi stubs and skeleton classes from a remote implementation class.
extern "mvn rmic:rmic" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates a jar containing the rmic generated classes.
extern "mvn rmic:package" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A plugin for processing grammar files in SableCC.
extern "mvn sablecc:generate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Translates SQLJ source code using the SQLJ Translator.
extern "mvn sqlj:sqlj" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Cleans out generated stale resources.
extern "mvn sqlj:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on sqlj-maven-plugin
extern "mvn sqlj:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on xdoclet-maven-plugin
extern "mvn xdoclet:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs XDoclet.
extern "mvn xdoclet:xdoclet" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A Maven 2 plugin which parses xsd files and produces a corresponding object model based on the Apache XML Beans parser
extern "mvn xmlbeans:xmlbeans-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on xmlbeans-maven-plugin
extern "mvn xmlbeans:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A Maven 2 plugin which parses xsd files and produces a corresponding object model based on the Apache XML Beans parser
extern "mvn xmlbeans:xmlbeans" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create the NetBeans auto update site definition.
extern "mvn nbm:autoupdate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Package branding resources for NetBeans platform/IDE based application
extern "mvn nbm:branding" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Build installers for Mavenized NetBeans application
extern "mvn nbm:build-installers" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create the NetBeans module clusters from reactor
extern "mvn nbm:cluster" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create the NetBeans module clusters/application for the 'nbm-application' packaging projects
extern "mvn nbm:cluster-app" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on nbm-maven-plugin
extern "mvn nbm:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal for generating NetBeans module system specific manifest entries, part of nbm lifecycle/packaging
extern "mvn nbm:manifest" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create the NetBeans module artifact (nbm file), part of 'nbm' lifecycle/packaging.
extern "mvn nbm:nbm" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run NetBeans IDE with additional custom module clusters, to be used in conjunction with nbm:cluster
extern "mvn nbm:run-ide" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run a branded application on top of NetBeans Platform
extern "mvn nbm:run-platform" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create a standalone application out of the composed clusters of nbm-application
extern "mvn nbm:standalone-zip" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create webstartable binaries for a 'nbm-application'.
extern "mvn nbm:webstart-app" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate a report from the Clirr output.
extern "mvn clirr:clirr" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Check for compatibility between two arbitrary artifact sets.
extern "mvn clirr:check-arbitrary" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on clirr-maven-plugin
extern "mvn clirr:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Check for compatibility with previous version.
extern "mvn clirr:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Check for compatibility with previous version without forking the project
extern "mvn clirr:check-no-fork" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Check the coverage percentages for unit tests from the last instrumentation, and optionally fail the build if the targets are not met
extern "mvn cobertura:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Check the coverage percentages for unit tests and integration tests from the last instrumentation, and optionally fail the build if the targets are not met
extern "mvn cobertura:check-integration-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Clean up the files that Cobertura Maven Plugin has created during instrumentation.
extern "mvn cobertura:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Instrument the compiled classes, run the unit tests and generate a Cobertura report.
extern "mvn cobertura:cobertura" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Instrument the compiled classes, run the unit tests and integration tests and generate a Cobertura report.
extern "mvn cobertura:cobertura-integration-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Output the contents of Cobertura's data file to the command line.
extern "mvn cobertura:dump-datafile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on cobertura-maven-plugin
extern "mvn cobertura:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Instrument the compiled classes.
extern "mvn cobertura:instrument" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which produces a changelog report based on the Subversion logs.
extern "mvn scmchangelog:report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on scmchangelog-maven-plugin
extern "mvn scmchangelog:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on sonar-maven-plugin
extern "mvn sonar:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Analyze project
extern "mvn sonar:sonar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Scans the source files for tags and generates a report on their occurrences.
extern "mvn taglist:taglist" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on taglist-maven-plugin
extern "mvn taglist:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Check the build if for any Method with a ccn greater than a limit in the source code
extern "mvn javancss:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on javancss-maven-plugin
extern "mvn javancss:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a JavaNCSS report based on this module's source code.
extern "mvn javancss:report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run JDepend and generate a site report
extern "mvn jdepend:generate-no-fork" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on jdepend-maven-plugin
extern "mvn jdepend:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run JDepend and generate a site report
extern "mvn jdepend:generate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create a CodeNarc Report.
extern "mvn codenarc:codenarc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on codenarc-maven-plugin
extern "mvn codenarc:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn findbugs:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn findbugs:findbugs" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Open the findbugs GUI to browse the report
extern "mvn findbugs:gui" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on findbugs-maven-plugin
extern "mvn findbugs:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This goal uses the fitnesse.runner.TestRunner class for getting result of a remote FitNesse web page execution
extern "mvn fitnesse:remotecall" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on fitnesse-maven-plugin
extern "mvn fitnesse:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This goal uses the fitnesse.runner.TestRunner class for calling a remote FitNesse web page and executes the tests or suites locally into a forked JVM
extern "mvn fitnesse:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a FitNesse report from a FitNesse web server
extern "mvn fitnesse:fitnesse" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Start the Selenium server.
extern "mvn selenium:start-server" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts an Xvfb instance suitable for handling X11 displays for headless systems
extern "mvn selenium:xvfb" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stop the Selenium server.
extern "mvn selenium:stop-server" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run a suite of HTML Selenese tests.
extern "mvn selenium:selenese" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on selenium-maven-plugin
extern "mvn selenium:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on webtest-maven-plugin
extern "mvn webtest:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Allows grepping through a set of files to find particular text strings and fail the build if one or matches are found
extern "mvn webtest:verify-filecontent" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Remove temporary data from running the Canoo WebTests
extern "mvn webtest:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs a Canoo WebTest defined in an ANT script.
extern "mvn webtest:test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs a Canoo WebTest in a loop until an error or failure occurs
extern "mvn webtest:loop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Prints the configuration settings.
extern "mvn webtest:info" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates the HTML report for a test run based on XSLT.
extern "mvn webtest:report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Checks the webtest result file for test failures and throws an exception if one or more tests failed
extern "mvn webtest:verify-result" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Invokes JMeter
extern "mvn chronos-jmeter:jmeter" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Checks the latest performancetests to verify that performance targets have been met
extern "mvn chronos-jmeter:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Invokes the JMeter gui
extern "mvn chronos-jmeter:jmetergui" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Analyzes output from JMeter
extern "mvn chronos-jmeter:jmeteroutput" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on chronos-jmeter-maven-plugin
extern "mvn chronos-jmeter:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Save a snapshot of the currently executed test to enable later historic reports.
extern "mvn chronos-jmeter:savehistory" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on chronos-surefire-maven-plugin
extern "mvn chronos-surefire:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which collects the execution of each performed unittest, and compares the execution time to previous measured execution times for the same test
extern "mvn chronos-surefire:collect" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates a historic report of performance test results.
extern "mvn chronos-report:historyreport" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates a report of the currently executed performancetest in html format.
extern "mvn chronos-report:report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on chronos-report-maven-plugin
extern "mvn chronos-report:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates an API Signature from at least one of: the java runtime, the module dependencies and the module classes.
extern "mvn animal-sniffer:build" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Checks the classes compiled by this module.
extern "mvn animal-sniffer:check" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on animal-sniffer-maven-plugin
extern "mvn animal-sniffer:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates JSW based daemon wrappers.
extern "mvn appassembler:generate-daemons" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Assembles the artifacts and generates bin scripts for the configured applications
extern "mvn appassembler:assemble" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates an appassembler repository
extern "mvn appassembler:create-repository" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on appassembler-maven-plugin
extern "mvn appassembler:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Parse a version string and set properties containing the component parts of the version
extern "mvn build-helper:parse-version" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Define one or many properties as a result of a Beanshell script invocation
extern "mvn build-helper:bsh-property" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Add more resource directories to the POM.
extern "mvn build-helper:add-resource" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Store the maven core version in a property maven.version.
extern "mvn build-helper:maven-version" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Attach additional artifacts to be installed and deployed.
extern "mvn build-helper:attach-artifact" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Add test source directories to the POM.
extern "mvn build-helper:add-test-source" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Resolve the latest released version of this project
extern "mvn build-helper:released-version" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Retrieve current host IP address and place it under a configurable project property
extern "mvn build-helper:local-ip" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Reserve a list of random and not in use network ports and place them in a configurable project properties.
extern "mvn build-helper:reserve-network-port" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Remove project's artifacts from local repository
extern "mvn build-helper:remove-project-artifact" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Add more source directories to the POM.
extern "mvn build-helper:add-source" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Add more test resource directories to the POM.
extern "mvn build-helper:add-test-resource" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Retrieve number of CPUs with project factor, and place it under a configurable project property
extern "mvn build-helper:cpu-count" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Sets a property based on the current date and time.
extern "mvn build-helper:timestamp-property" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Sets a property by applying a regex replacement rule to a supplied value
extern "mvn build-helper:regex-properties" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Sets a property by applying a regex replacement rule to a supplied value.
extern "mvn build-helper:regex-property" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on build-helper-maven-plugin
extern "mvn build-helper:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This mojo is designed to give you a timestamp available through one or more properties
extern "mvn buildnumber:create-timestamp" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This mojo is designed to give you a build number
extern "mvn buildnumber:create" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on buildnumber-maven-plugin
extern "mvn buildnumber:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal which sets project properties for changeSet and changeSetDate from the current Mercurial repository.
extern "mvn buildnumber:hgchangeset" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on cassandra-maven-plugin
extern "mvn cassandra:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Loads a cassandra-cli bscript into a Cassandra instance.
extern "mvn cassandra:load" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deletes the Cassandra home directory that we create for running Cassandra.
extern "mvn cassandra:delete" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts a Cassandra instance in the background.
extern "mvn cassandra:start-cluster" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Loads a CassandraUnit DataSet into a Cassandra instance.
extern "mvn cassandra:cu-load" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stops a background Cassandra instance.
extern "mvn cassandra:stop-cluster" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs nodetool repair on a Cassandra instance.
extern "mvn cassandra:repair" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Executes cql statements from maven.
extern "mvn cassandra:cql-exec" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stops a background Cassandra instance.
extern "mvn cassandra:stop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs nodetool flush on a Cassandra instance.
extern "mvn cassandra:flush" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs Cassandra in the foreground.
extern "mvn cassandra:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts a Cassandra instance in the background.
extern "mvn cassandra:start" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs nodetool cleanup on a Cassandra instance.
extern "mvn cassandra:cleanup" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs nodetool compact on a Cassandra instance.
extern "mvn cassandra:compact" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on ditaot-maven-plugin
extern "mvn ditaot:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display DITA Open Toolkit's built-in version, with option to insert a custom version found under \${dita.dir}/ditaotVersionPath, via version property to Maven's \${versionName}
extern "mvn ditaot:version" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate http://www.dita-op.org's Eclipse configuration to allow editing, previewing DITA under Eclipse IDE.
extern "mvn ditaot:eclipse" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display DITA Open Toolkit's common Ant properties usage
extern "mvn ditaot:print-help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Convert DITA Open Toolkit's Microsoft CHM output file, produced by htmlhelp transtype, to pure HTML set of files
extern "mvn ditaot:chm2web" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Execute DITA Open Toolkit's Ant command line to transform DITA files to desired output format
extern "mvn ditaot:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A Plugin for executing external programs.
extern "mvn exec:exec" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on exec-maven-plugin
extern "mvn exec:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Executes the supplied java class in the current VM with the enclosing project's dependencies as classpath.
extern "mvn exec:java" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# A Mojo that deletes a generated keystore file.
extern "mvn keytool:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To export a certificate from a keystore
extern "mvn keytool:exportCertificate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To change the key password of an entry of a keystore
extern "mvn keytool:changeKeyPassword" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To generate a secret key into a keystore
extern "mvn keytool:generateSecretKey" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To import all entries of a keystore to another keystore
extern "mvn keytool:importKeystore" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To change the store password of a keystore
extern "mvn keytool:changeStorePassword" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To import a certificate into a keystore
extern "mvn keytool:importCertificate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To generate certificate request
extern "mvn keytool:generateCertificateRequest" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To list entries in a keystore
extern "mvn keytool:list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To print the content of a certificate request
extern "mvn keytool:printCertificateRequest" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To print the content of a certificate
extern "mvn keytool:printCertificate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To delete an entry alias from a keystore
extern "mvn keytool:deleteAlias" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on keytool-maven-plugin
extern "mvn keytool:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To generate a key pair into a keystore
extern "mvn keytool:generateKeyPair" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To change an entry alias into a keystore
extern "mvn keytool:changeAlias" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To print the content of a CRL file
extern "mvn keytool:printCRLFile" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# To generate certificate from a certificate request from a keystore
extern "mvn keytool:generateCertificate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on latex-maven-plugin
extern "mvn latex:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# LaTeX documents building goal.
extern "mvn latex:latex" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a report of all third-parties detected in the module.
extern "mvn license:third-party-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# The goal to check if the state of header on project source files.
extern "mvn license:check-file-header" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Goal to generate the third-party license file
extern "mvn license:add-third-party" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Updates (or creates) the main project license file according to the given license defines as licenseName
extern "mvn license:update-project-license" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on license-maven-plugin
extern "mvn license:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This goal forks executions of the add-third-party goal for all the leaf projects of the tree of modules below the point where it is executed
extern "mvn license:aggregate-add-third-party" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display all available licenses.
extern "mvn license:license-list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays all the available comment style to box file headers.
extern "mvn license:comment-style-list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# The goal to update (or add) the header on project source files
extern "mvn license:update-file-header" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Download the license files of all the current project's dependencies, and generate a summary file containing a list of all dependencies and their licenses.
extern "mvn license:download-licenses" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generate the scan results as part of the site.
extern "mvn ounce:report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This mojo generates an Ounce application file
extern "mvn ounce:application" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This mojo allows an on demand scan of an application and the optional publishing of the results.
extern "mvn ounce:scan" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This mojo generates an Ounce project file
extern "mvn ounce:project-only" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# This mojo generates an Ounce project file
extern "mvn ounce:project" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on ounce-maven-plugin
extern "mvn ounce:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Construct the RPM file and attaches it as a secondary artifact.
extern "mvn rpm:attached-rpm" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on rpm-maven-plugin
extern "mvn rpm:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Construct the RPM file.
extern "mvn rpm:rpm" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Makes the rpm version and release attributes available as properties.
extern "mvn rpm:version" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Call mvn siteskinner:skin on a maven project
extern "mvn siteskinner:skin" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on siteskinner-maven-plugin
extern "mvn siteskinner:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on sql-maven-plugin
extern "mvn sql:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Executes SQL against a database.
extern "mvn sql:execute" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# List all files in the archive.
extern "mvn truezip:list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display an archive's list to console
extern "mvn truezip:ls" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy an archive/directory to another archive/directory
extern "mvn truezip:cp" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Remove a set of files from an existing archive.
extern "mvn truezip:remove" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy a set of files in and out of an existing archive.
extern "mvn truezip:copy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Move a single file or multiple files (via FileSet) between archives or directories.
extern "mvn truezip:move" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on truezip-maven-plugin
extern "mvn truezip:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update open archives immediately, flush cached data to disk.
extern "mvn truezip:update" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Removes the initial backup of the pom, thereby accepting the changes.
extern "mvn versions:commit" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Compare dependency versions of the current project to dependencies or dependency management of a remote repository project
extern "mvn versions:compare-dependencies" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a report of available updates for the dependencies of a project.
extern "mvn versions:dependency-updates-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays all dependencies that have newer versions available.
extern "mvn versions:display-dependency-updates" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays any updates of the project's parent project
extern "mvn versions:display-parent-updates" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays all plugins that have newer versions available.
extern "mvn versions:display-plugin-updates" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Displays properties that are linked to artifact versions and have updates available.
extern "mvn versions:display-property-updates" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any -SNAPSHOT versions with a release version, older if necessary (if there has been a release).
extern "mvn versions:force-releases" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on versions-maven-plugin
extern "mvn versions:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Attempts to resolve unlocked snapshot dependency versions to the locked timestamp versions used in the build
extern "mvn versions:lock-snapshots" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a report of available updates for the plugins of a project.
extern "mvn versions:plugin-updates-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a report of available updates for properties of a project which are linked to the dependencies and/or plugins of a project.
extern "mvn versions:property-updates-report" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Attempts to resolve dependency version ranges to the specific version being used in the build
extern "mvn versions:resolve-ranges" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Restores the pom from the initial backup.
extern "mvn versions:revert" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Sets the current project's version and based on that change propagates that change onto any child modules as necessary.
extern "mvn versions:set" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Attempts to resolve unlocked snapshot dependency versions to the locked timestamp versions used in the build
extern "mvn versions:unlock-snapshots" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Scans the current projects child modules, updating the versions of any which use the current project to the version of the current project.
extern "mvn versions:update-child-modules" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Sets the parent version to the latest parent version.
extern "mvn versions:update-parent" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Sets properties to the latest versions of specific artifacts.
extern "mvn versions:update-properties" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Sets a property to the latest version in a given range of associated artifacts.
extern "mvn versions:update-property" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any release versions with the latest release version.
extern "mvn versions:use-latest-releases" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any release versions with the latest snapshot version (if it has been deployed).
extern "mvn versions:use-latest-snapshots" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any version with the latest version.
extern "mvn versions:use-latest-versions" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any release versions with the next release version (if it has been released).
extern "mvn versions:use-next-releases" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any release versions with the next snapshot version (if it has been deployed).
extern "mvn versions:use-next-snapshots" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any version with the latest version.
extern "mvn versions:use-next-versions" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any versions with the corresponding version from the reactor.
extern "mvn versions:use-reactor" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Replaces any -SNAPSHOT versions with the corresponding release version (if it has been released).
extern "mvn versions:use-releases" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy files from one VFS to another VFS
extern "mvn vfs:copy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on vfs-maven-plugin
extern "mvn vfs:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display file list of a virtual file system.
extern "mvn vfs:list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Merge Maven repository from one VFS to another VFS
extern "mvn vfs:merge-maven-repositories" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Move files from a virtual file system to another
extern "mvn vfs:move" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Remove files from a virtual file system
extern "mvn vfs:remove" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# The ValidatorMojo's task is the validation of XML files against a given schema.
extern "mvn xml:validate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on xml-maven-plugin
extern "mvn xml:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# The TransformMojo is used for transforming a set of files using a common stylesheet.
extern "mvn xml:transform" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Releases a single closed Nexus staging repository into a permanent Nexus repository for general consumption.
extern "mvn nexus-staging:rc-release" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Closes a Nexus staging repository.
extern "mvn nexus-staging:close" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Alternative deploy mojo, that will select proper DeployStrategy to perform deploys
extern "mvn nexus-staging:deploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Promotes a closed Nexus staging repository into a Nexus Build Promotion Profile.
extern "mvn nexus-staging:promote" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys the (previously) locally staged artifacts from nexus-staging repository, that were staged using DeployMojo and having the DeployMojo.skipRemoteStaging flag set to true.
extern "mvn nexus-staging:deploy-staged" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Drops a Nexus staging repository that is either open or closed.
extern "mvn nexus-staging:rc-drop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Promotes a closed Nexus staging repository into a Nexus Build Promotion Profile.
extern "mvn nexus-staging:rc-promote" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on nexus-staging-maven-plugin
extern "mvn nexus-staging:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Drops a Nexus staging repository that is either open or closed.
extern "mvn nexus-staging:drop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys the (previously) staged artifacts from some local repository, that were staged using maven-deploy-plugin together with switch altDeploymentRepository for cases when POM modifications are not possible for some reason
extern "mvn nexus-staging:deploy-staged-repository" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Releases a single closed Nexus staging repository into a permanent Nexus repository for general consumption.
extern "mvn nexus-staging:release" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Lists staging repositories accessible by current user available on Nexus.
extern "mvn nexus-staging:rc-list" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Lists staging profiles accessible by current user available on Nexus.
extern "mvn nexus-staging:rc-list-profiles" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Closes a Nexus staging repository.
extern "mvn nexus-staging:rc-close" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Delete unused indexes from application.
extern "mvn appengine:vacuum_indexes" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts the App Engine development server and does not wait.
extern "mvn appengine:devserver_start" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Start the specified backend.
extern "mvn appengine:backends_start" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stops the App Engine development server.
extern "mvn appengine:devserver_stop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Roll back a previously in-progress update.
extern "mvn appengine:backends_rollback" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Start the specified module version.
extern "mvn appengine:start_module_version" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Change the default version, but more gently than set_default_version.
extern "mvn appengine:migrate_traffic" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update application dispatch.xml.
extern "mvn appengine:update_dispatch" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# App Engine endpoints get-client-lib … command.
extern "mvn appengine:endpoints_get_client_lib" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Debug the specified VM Runtime instance.
extern "mvn appengine:debug" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Set the default serving version.
extern "mvn appengine:set_default_version" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs the datanucleus enhancer.
extern "mvn appengine:enhance" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Create or update an app version.
extern "mvn appengine:update" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Maven project version is dot based, e.g '1.9.15' , whereas appengine-web.xml is dash based, e.g
extern "mvn appengine:create-property" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Configure the specified backend.
extern "mvn appengine:backends_configure" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update application cron jobs.
extern "mvn appengine:update_cron" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs the App Engine development server.
extern "mvn appengine:devserver" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Delete the specified backend.
extern "mvn appengine:backends_delete" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update the specified backend or all backends.
extern "mvn appengine:backends_update" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update application indexes.
extern "mvn appengine:update_indexes" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update application task queue definitions.
extern "mvn appengine:update_queues" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stop the specified module version.
extern "mvn appengine:stop_module_version" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Rollback an in-progress update.
extern "mvn appengine:rollback" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Update application DoS protection configuration.
extern "mvn appengine:update_dos" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# App Engine endpoints get-discovery-doc command.
extern "mvn appengine:endpoints_get_discovery_doc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Stop the specified backend.
extern "mvn appengine:backends_stop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates an Android Archive (aar) file
extern "mvn android:aar" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates the apk file
extern "mvn android:apk" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates the apklib file
extern "mvn android:apklib" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn android:clean" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Connect external IP addresses to the ADB server.
extern "mvn android:connect" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys the apk(s) of the current project(s) to all attached devices and emulators
extern "mvn android:deploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys a specified Android application apk to attached devices and emulators
extern "mvn android:deploy-apk" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Deploys all directly declared dependencies of <type>apk</type> in this project's pom
extern "mvn android:deploy-dependencies" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# DevicesMojo lists all attached devices and emulators found with the android debug bridge
extern "mvn android:devices" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Converts compiled Java classes to the Android dex format.
extern "mvn android:dex" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Disconnect external IP addresses from the ADB server.
extern "mvn android:disconnect" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# After compiled Java classes use emma tool
extern "mvn android:emma" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# EmulatorStartMojo can start the Android Emulator with a specified Android Virtual Device (avd).
extern "mvn android:emulator-start" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# EmulatorStartMojo can stop the Android Emulator with a specified Android Virtual Device (avd).
extern "mvn android:emulator-stop" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# EmulatorStopeAllMojo will stop all attached devices.
extern "mvn android:emulator-stop-all" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates R.java based on resources specified by the resources configuration parameter
extern "mvn android:generate-sources" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on android-maven-plugin
extern "mvn android:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs the instrumentation apk on device.
extern "mvn android:instrument" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Internal
extern "mvn android:internal-integration-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Internal
extern "mvn android:internal-pre-integration-test" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# LintMojo can run the lint command against the project
extern "mvn android:lint" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Manifest Merger V2 AndroidManifest.xml file
extern "mvn android:manifest-merger" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Updates various version attributes present in the AndroidManifest.xml file.
extern "mvn android:manifest-update" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Execute tests using UI/Application Exerciser Monkey
extern "mvn android:monkey" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Execute monkey runner programs
extern "mvn android:monkeyrunner" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn android:ndk-build" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Process both application and dependency classes using the ProGuard byte code obfuscator, minimzer, and optimizer
extern "mvn android:proguard" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn android:publish-apk" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn android:publish-listing" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy file or directory from all the attached (or specified) devices/emulators.
extern "mvn android:pull" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Copy file to all the attached (or specified) devices/emulators.
extern "mvn android:push" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Undeploys and the deploys (= redeploys) the apk(s) of the current project(s) to all attached devices and emulators
extern "mvn android:redeploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Reploys a specified Android application apk to attached devices and emulators
extern "mvn android:redeploy-apk" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Runs the first Activity shown in the top-level launcher as determined by its Intent filters
extern "mvn android:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Can execute tests using ui uiautomator
extern "mvn android:uiautomator" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Undeploys the apk(s) of the current project(s) to all attached devices and emulators
extern "mvn android:undeploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Undeploys a specified Android application apk from attached devices and emulators
extern "mvn android:undeploy-apk" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Unpack libraries code and dependencies into target
extern "mvn android:unpack" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# ZipalignMojo can run the zipalign command against the apk
extern "mvn android:zipalign" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Removes any Liquibase updater locks from the current database.
extern "mvn liquibase:releaseLocks" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Writes a Liquibase tag to the database.
extern "mvn liquibase:tag" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Drops all database objects in the configured schema(s)
extern "mvn liquibase:dropAll" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the SQL that is required to update the database to the current version as specified in the DatabaseChangeLogs.
extern "mvn liquibase:updateSQL" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Lists all Liquibase updater locks on the current database.
extern "mvn liquibase:listLocks" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Liquibase Migration Maven plugin
extern "mvn liquibase:migrate" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Marks all unapplied changes to the database as applied in the change log.
extern "mvn liquibase:changelogSync" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Clears all checksums in the current changelog, so they will be recalculated next update.
extern "mvn liquibase:clearCheckSums" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates dbDocs against the database.
extern "mvn liquibase:dbDoc" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the SQL that is required to rollback the database to the specified pointing attributes 'rollbackCount', 'rollbackTag'
extern "mvn liquibase:rollbackSQL" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Prints which changesets need to be applied to the database.
extern "mvn liquibase:status" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates SQL that marks all unapplied changes as applied.
extern "mvn liquibase:changelogSyncSQL" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Applies the DatabaseChangeLogs to the database, testing rollback
extern "mvn liquibase:updateTestingRollback" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on liquibase-maven-plugin
extern "mvn liquibase:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Invokes Liquibase rollbacks on a database.
extern "mvn liquibase:rollback" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates the SQL that is required to rollback the database to current state after the next update.
extern "mvn liquibase:futureRollbackSQL" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates a diff between the specified database and the reference database
extern "mvn liquibase:diff" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Applies the DatabaseChangeLogs to the database
extern "mvn liquibase:update" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Generates SQL that marks all unapplied changes as applied.
extern "mvn liquibase:generateChangeLog" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Creates an SQL migration script using the provided DatabaseChangeLog(s)
extern "mvn liquibase:migrateSQL" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# 
extern "mvn jgitflow:feature-deploy" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Finishes a release
extern "mvn jgitflow:release-finish" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts a hotfix
extern "mvn jgitflow:hotfix-start" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Finishes a hotfix
extern "mvn jgitflow:hotfix-finish" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Finishes a feature branch
extern "mvn jgitflow:feature-finish" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Updates the pom versions in the current branch by adding a build number label
extern "mvn jgitflow:build-number" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts a release
extern "mvn jgitflow:release-start" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Starts a feature branch
extern "mvn jgitflow:feature-start" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Display help information on spring-boot-maven-plugin
extern "mvn spring-boot:help" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Repackage JAR and WAR for use with java -jar
extern "mvn spring-boot:repackage" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]

# Run an executable archive application
extern "mvn spring-boot:run" [
	--also-make					# If project list is specified, also build projects required by the list
	--also-make-dependents					# If project list is specified, also build projects that depend on projects on the list
	--batch-mode					# Run in non-interactive (batch) mode
	--strict-checksums					# Fail the build if checksums don't match
	--lax-checksums					# Warn if checksums don't match
	--check-plugin-updates					# Ineffective, only kept for backward compatibility
	--define					# Define a system property
	--errors					# Produce execution error messages
	--encrypt-master-password					# Encrypt master security password
	--encrypt-password					# Encrypt server password
	--fail-at-end					# Only fail the build afterwards; allow all non-impacted builds to continue
	--fail-fast					# Stop at first failure in reactorized builds
	--fail-never					# NEVER fail the build, regardless of project result
	--help					# Display help information
	--legacy-local-repository					# Use Maven 2 Legacy Local Repository behaviour, ie no use of _remote.repositories
	--non-recursive					# Do not recurse into sub-projects
	--no-plugin-registry					# Ineffective, only kept for backward compatibility
	--no-plugin-updates					# Ineffective, only kept for backward compatibility
	--no-snapshot-updates					# Suppress SNAPSHOT updates
	--offline					# Work offline
	--quiet					# Quiet output - only show errors
	--update-snapshots					# Forces a check for missing releases and updated snapshots on remote repositories
	--update-plugins					# Ineffective, only kept for backward compatibility
	--show-version					# Display version information WITHOUT stopping build
	--version					# Display version information
	--debug					# Produce execution debug output
	...args
]